"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UseSaveEntryDecorator = void 0;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _react = require("react");
var _hooks = require("../../hooks");
var _appHeadlessCms = require("@webiny/app-headless-cms");
var _appAdmin = require("@webiny/app-admin");
var _ContentEntryEditorCo = _appHeadlessCms.ContentEntryEditorConfig.ContentEntry,
  ContentEntryForm = _ContentEntryEditorCo.ContentEntryForm,
  useContentEntry = _ContentEntryEditorCo.useContentEntry;
var UseSaveEntryDecorator = exports.UseSaveEntryDecorator = ContentEntryForm.useContentEntryForm.createDecorator(function (originalHook) {
  return function useRecordLockingUseSave() {
    var hook = originalHook();
    var _useContentEntry = useContentEntry(),
      entry = _useContentEntry.entry,
      model = _useContentEntry.contentModel;
    var _useRecordLocking = (0, _hooks.useRecordLocking)(),
      fetchLockedEntryLockRecord = _useRecordLocking.fetchLockedEntryLockRecord,
      updateEntryLock = _useRecordLocking.updateEntryLock;
    var _useSnackbar = (0, _appAdmin.useSnackbar)(),
      showSnackbar = _useSnackbar.showSnackbar;
    var saveEntry = (0, _react.useCallback)(async function () {
      if (!entry.id) {
        return hook.saveEntry.apply(hook, arguments);
      }
      var result = await fetchLockedEntryLockRecord({
        id: entry.id,
        $lockingType: model.modelId
      });
      if (result?.lockedBy) {
        var lockedBy = result.lockedBy;
        showSnackbar("It seems that the entry is locked by ".concat(lockedBy.displayName || lockedBy.id, ". You can't save your changes."));
        return null;
      }
      var saveResult = await hook.saveEntry.apply(hook, arguments);
      if (saveResult) {
        await updateEntryLock({
          id: saveResult.id,
          $lockingType: model.modelId
        });
      }
      return saveResult;
    }, [entry?.id, model.modelId, updateEntryLock]);
    return (0, _objectSpread2.default)((0, _objectSpread2.default)({}, hook), {}, {
      saveEntry: saveEntry
    });
  };
});

//# sourceMappingURL=UseSaveEntryDecorator.js.map